/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.63 Revision 1.66
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.63 2007/01/08 23:25:30 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.66 2007/05/30 15:45:01 cardoe Exp $
4# 4#
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# Maintainer: base-system@gentoo.org
6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
7# 6#
8# This eclass is for handling autotooled software packages that 7# This eclass is for handling autotooled software packages that
9# needs to regenerate their build scripts. 8# needs to regenerate their build scripts.
10# 9#
11# NB: If you add anything, please comment it! 10# NB: If you add anything, please comment it!
19_autoconf_atom="sys-devel/autoconf" 18_autoconf_atom="sys-devel/autoconf"
20if [[ -n ${WANT_AUTOMAKE} ]]; then 19if [[ -n ${WANT_AUTOMAKE} ]]; then
21 case ${WANT_AUTOMAKE} in 20 case ${WANT_AUTOMAKE} in
22 # workaround while we have different versions of automake in arch and ~arch 21 # workaround while we have different versions of automake in arch and ~arch
23 none) _automake_atom="" ;; # some packages don't require automake at all 22 none) _automake_atom="" ;; # some packages don't require automake at all
24 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 23 latest) _automake_atom="=sys-devel/automake-1.10*" ;;
25 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 24 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
26 esac 25 esac
26 [[ ${WANT_AUTOMAKE} == "latest" ]] && WANT_AUTOMAKE="1.10"
27 export WANT_AUTOMAKE
27fi 28fi
28 29
29if [[ -n ${WANT_AUTOCONF} ]] ; then 30if [[ -n ${WANT_AUTOCONF} ]] ; then
30 case ${WANT_AUTOCONF} in 31 case ${WANT_AUTOCONF} in
31 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 32 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
32 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 33 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;;
33 esac 34 esac
35 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
36 export WANT_AUTOCONF
34fi 37fi
35DEPEND="${_automake_atom} 38DEPEND="${_automake_atom}
36 ${_autoconf_atom} 39 ${_autoconf_atom}
37 sys-devel/libtool" 40 sys-devel/libtool"
38RDEPEND="" 41RDEPEND=""
59# eautoconf - Runs autoconf. 62# eautoconf - Runs autoconf.
60# eautoheader - Runs autoheader. 63# eautoheader - Runs autoheader.
61# eautomake - Runs automake 64# eautomake - Runs automake
62# 65#
63 66
64# XXX: M4DIR should be depreciated 67# XXX: M4DIR should be deprecated
65AT_M4DIR=${AT_M4DIR:-${M4DIR}} 68AT_M4DIR=${AT_M4DIR:-${M4DIR}}
66AT_GNUCONF_UPDATE="no" 69AT_GNUCONF_UPDATE="no"
67 70
68 71
69# This function mimes the behavior of autoreconf, but uses the different 72# This function mimes the behavior of autoreconf, but uses the different
121 ;; 124 ;;
122 esac 125 esac
123 done 126 done
124 fi 127 fi
125 128
126 autotools_set_versions
127 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 129 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
128 autotools_run_tool aclocal "$@" ${aclocal_opts} 130 autotools_run_tool aclocal "$@" ${aclocal_opts}
129} 131}
130 132
131_elibtoolize() { 133_elibtoolize() {
147} 149}
148 150
149eautoheader() { 151eautoheader() {
150 # Check if we should run autoheader 152 # Check if we should run autoheader
151 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 153 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
152 autotools_set_versions
153 NO_FAIL=1 autotools_run_tool autoheader "$@" 154 NO_FAIL=1 autotools_run_tool autoheader "$@"
154} 155}
155 156
156eautoconf() { 157eautoconf() {
157 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 158 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
159 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 160 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!"
160 echo 161 echo
161 die "No configure.{ac,in} present!" 162 die "No configure.{ac,in} present!"
162 fi 163 fi
163 164
164 autotools_set_versions
165 autotools_run_tool autoconf "$@" 165 autotools_run_tool autoconf "$@"
166} 166}
167 167
168eautomake() { 168eautomake() {
169 local extra_opts 169 local extra_opts
170 170
171 [[ -f Makefile.am ]] || return 0 171 [[ -f Makefile.am ]] || return 0
172 172
173 autotools_set_versions
174 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 173 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then
175 local used_automake 174 local used_automake
176 local installed_automake 175 local installed_automake
177 176
178 installed_automake=$(automake --version | head -n 1 | \ 177 installed_automake=$(automake --version | head -n 1 | \
193 192
194 # --force-missing seems not to be recognized by some flavours of automake 193 # --force-missing seems not to be recognized by some flavours of automake
195 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 194 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
196} 195}
197 196
198autotools_set_versions() {
199 [[ -n ${autotools_version_sets} ]] && return 0
200
201 if [[ -n ${WANT_AUTOCONF} ]]; then
202 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
203 export WANT_AUTOCONF
204 einfo "Requested autoconf ${WANT_AUTOCONF}"
205 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
206 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
207 else
208 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
209 fi
210
211 if [[ -n ${WANT_AUTOMAKE} ]]; then
212 local latest_automake
213 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
214 latest_automake="latest: "
215 for amver in 1.10 1.9 1.8 1.7 1.6; do
216 WANT_AUTOMAKE="${amver}"
217 ROOT=/ has_version =sys-devel/automake-${amver}* && break
218 done
219 fi
220
221 # Don't do stuff if no autoamke is requested/required
222 if [[ ${WANT_AUTOMAKE} != "none" ]]; then
223 export WANT_AUTOMAKE
224 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
225 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
226 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
227 fi
228 else
229 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
230 fi
231
232 autotools_version_sets="yes"
233}
234
235# Internal function to run an autotools' tool 197# Internal function to run an autotools' tool
236autotools_run_tool() { 198autotools_run_tool() {
237 local STDERR_TARGET="${T}/$$.out" 199 local STDERR_TARGET="${T}/$$.out"
238 local ris 200 local ris
239 201

Legend:
Removed from v.1.63  
changed lines
  Added in v.1.66

  ViewVC Help
Powered by ViewVC 1.1.20